<%@ Page Language="C#" AutoEventWireup="true" CodeFile="protect.aspx.cs" Inherits="enc_test2" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title>Web.Config Protect Utility</title>
    <style type="text/css">
      body, td, th { font-family: Tahoma; font-size: 10pt; margin-top:50px; }
      th { font-weight: bold; }
      table { background-color: #c0c0c0; }
      table th { background-color: #e0e0e0; }
      table td { background-color: white; }
    </style>
</head>
<body>
    <form id="form1" runat="server">
    <div style="width:800px;margin:auto;">
    
      <asp:Literal runat="server" id="litMessage" enableviewstate="false" />

      <table border="0" cellspacing="1" cellpadding="4" width="100%">
        <tr><th colspan="2">Web.Config Protection Information</th></tr>
        <tr><td colspan="2"><b>WARNING:</b> This script makes modifications to your web.config. It is HIGHLY recommended you backup your web.config. You assume all liability in use of this script.</td></tr>
        <tr>
          <td>Available Protection Providers:</td>
          <td><asp:DropDownList runat="server" id="ddlProviders" onload="ddlProviders_Load"><asp:ListItem value="" text="(Select Provider)" /></asp:DropDownList></td>
        </tr>
        
        <asp:MultiView runat="server" id="mvRsaCryptoServiceProvider" activeviewindex="0">
          <asp:View runat="server" id="view1">
          
            <tr>
              <td colspan="2" style="color:#999999;">
                <div style="font-weight:bold;color:red;">Recommended Method:</div>
                You can use the <b>RsaCryptoServiceProvider</b> with <b>your own custom RSA Keys</b> by adding the following into your web.config, in the configuration node after the configSections node (if it exists)...<br /><br />
                <div style="font-family:Courier New;font-size:8pt;">
                  &lt;configProtectedData&gt;<br />
            &lt;providers&gt;<br />
                &lt;add keyContainerName="InsertMyCustomKeyHere"<br />
                &nbsp;&nbsp;&nbsp;useMachineContainer="true"<br />
                &nbsp;&nbsp;&nbsp;description="Uses RsaCryptoServiceProvider to encrypt and decrypt"<br />
                &nbsp;&nbsp;&nbsp;name="MyRsaCryptoServiceProvider"<br />
                &nbsp;&nbsp;&nbsp;type="System.Configuration.RsaProtectedConfigurationProvider,System.Configuration, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" /&gt;
            &lt;/providers&gt;<br />
        &lt;/configProtectedData&gt;<br />
                </div>
                <br /><br />
                <b>keyContainerName</b> -- Name for your Key Container.  Duplicate keys with the same keyContainerName cannot exist on the same machine.
              </td>
            </tr>
            
          </asp:View>
          <asp:View runat="server" id="view2">
          
            <tr>
              <td colspan="2" style="color:#999999;">
              
                 <b>HOWTO:</b> Create and Export your RSA keys for your <b>MyRsaCryptoServiceProvider</b>.
                 <ul>
                   <li><b>Step 1: Create the RSA Keys.</b>
                     <ul>
                       <li>Open up your Visual Studio 2005 Command prompt, or locate your aspnet_regiis file.</li>
                       <li>Run the following command and replace <font face="Courier New">&lt;ContainerName&gt;</font> with the <font face="Courier New">keyContainerName</font> from your web.config.<br />
                         &nbsp;&nbsp;&nbsp;<font face="Courier New">aspnet_regiis -pc "&lt;ContainerName&gt;" -exp</font>.</li>
                       <li>If successfull, you should see the following message<br />
                         &nbsp;&nbsp;&nbsp;<font face="Courier New">Creating RSA Key container...</font><br />
                         &nbsp;&nbsp;&nbsp;<font face="Courier New">Succeeded!</font>
                       </li>
                     </ul>
                   <li><b>Step 2: Give your ASPNET user permission to access the key.</b>
                     <ul>
                       <li>Run the following command, replacing &lt;ContainerName&gt; with your the <font face="Courier New">keyContainerName</font> from your web.config and<br />
                         <font face="Courier New">&lt;AspnetUser&gt;</font> with the name of your ASPNET user.<br />
                         &nbsp;&nbsp;&nbsp;<font face="Courier New">aspnet_regiis -pa "&lt;ContainerName&gt;" "&lt;AspnetUser&gt;"</font>
                       </li>
                       <li>If successfull, you should see the following message<br />
                         &nbsp;&nbsp;&nbsp;<font face="Courier New">Adding ACL for access to the RSA Key container...</font><br />
                         &nbsp;&nbsp;&nbsp;<font face="Courier New">Succeeded!</font>
                       </li>
                     </ul>
                   </li>
                   <li><b>Step 3: Export your RSA Keys.</b>
                     <ul>
                       <li>Run the following command and replace <font face="Courier New">&lt;ContainerName&gt;</font> with the <font face="Courier New">keyContainerName</font> from your web.config.<br />
                         &nbsp;&nbsp;&nbsp;<font face="Courier New">aspnet_regiis -px "&lt;ContainerName&gt;" "C:\MyCustomKeys.xml" -pri</font>
                         <br /><br />
                         Note: The <b>-pri</b> switch causes the private and public key to be exported. This enables both encryption and decryption. Without the
                         <b>pri</b> switch, you would only be able to encrypt data with the exported key. 
                     </ul>
                   </li>
                   <li><b>Step 4: Send your Exported Custom Keys to your System Administrator for importing.</b>
                     <ul><li>Hopefully System Administrator allows importing of keys.</li></ul>
                   </li>
                 </ul>
              
              </td>
            </tr>
            
          </asp:View>
        </asp:MultiView>
        
        <asp:PlaceHolder runat="server" id="phRsaCryptoServiceProvider">
        </asp:PlaceHolder>
        <asp:PlaceHolder runat="server" id="phDpapiProtectedConfigurationProvider">
        <tr>
          <td colspan="2" style="color:#999999;">
            You can use the <b>DpapiProtectedConfigurationProvider</b> by adding the following into your web.config, in the configuration node after the configSections node (if it exists)...<br /><br />
            <div style="font-family:Courier New;font-size:8pt;">
              &lt;configProtectedData&gt;<br />
        &lt;providers&gt;<br />
            &lt;add useMachineProtection="false" keyEntropy=""<br />
            &nbsp;&nbsp;&nbsp;name="MyDpapiProtectedConfigurationProvider" <br />
            &nbsp;&nbsp;&nbsp;type="System.Configuration.DpapiProtectedConfigurationProvider, System.Configuration, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" /&gt;<br />
        &lt;/providers&gt;<br />
    &lt;/configProtectedData&gt;<br />
            </div>
            <br /><br />
            <b>keyEntrophy</b> -- An application-specific value to include with the encryption key to protect against other applications being able to decrypt encrypted information. For more information, refer to the OptionalEntropy parameter of the CryptProtectData method of the Windows data protection API (DPAPI).
          </td>
        </tr>
        </asp:PlaceHolder>
        <tr>
          <td>appSettings</td>
          <td>
            <b><asp:Literal runat="server" id="litAppSettingsEncrypted" /></b>
            &nbsp;&nbsp;
            <asp:linkbutton runat="server" id="btnAppSettings" oncommand="btnProtect_Command" commandargument="appSettings" />
          </td>
        </tr>
        <tr>
          <td>connectionStrings</td>
          <td>
            <b><asp:Literal runat="server" id="litConnectionStringsEncrypted" /></b>
            &nbsp;&nbsp;
            <asp:linkbutton runat="server" id="btnConnectionStrings" oncommand="btnProtect_Command" commandargument="connectionStrings" />
          </td>
        </tr>
        <tr>
          <td>identity</td>
          <td>
            <b><asp:Literal runat="server" id="litIdentityEncrypted" /></b>
            &nbsp;&nbsp;
            <asp:linkbutton runat="server" id="btnIdentity" oncommand="btnProtect_Command" commandargument="identity" />
          </td>
        </tr>
        <tr>
          <td>sessionState</td>
          <td>
            <b><asp:Literal runat="server" id="litSessionStateEncrypted" /></b>
            &nbsp;&nbsp;
            <asp:linkbutton runat="server" id="btnSessionState" oncommand="btnProtect_Command" commandargument="identity" />
          </td>
        </tr>
      </table>

    </div>
    </form>
</body>
</html>
